Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.gui.terminal
Class Terminal

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  org.ka2ddo.yaac.gui.terminal.Terminal

All Implemented Interfaces:
  java.awt.event.KeyListener, java.awt.event.MouseListener, java.awt.event.MouseMotionListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Runnable, java.util.EventListener

    public final class Terminal

extends javax.swing.JComponent
implements java.lang.Runnable, java.awt.event.KeyListener, java.awt.event.MouseListener, java.awt.event.MouseMotionListener

This class implements a simple Terminal window to access interface ports for debugging. It opens input and output streams to the specified device (Internet socket or RXTX serial device), interprets the bytes from the input stream as ISO-8859-1 characters (including control characters) to display, and accepts user input from the keyboard and sends it to the output stream (optionally locally echoing the entered characters to the screen). The screen implements a simple emulation of a DEC VT102 screen. It will be 24 lines tall and either 80 or 132 characters wide. The screen maintains positional and escape sequence context state from the input characters.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JComponent
`javax.swing.JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`Terminal(java.io.InputStream is, java.io.OutputStream os, java.lang.String portName, boolean echoed)`

Method Summary
`int` | `available()`
`void` | `close()`
`int` | `getHeight()` Returns the current height of this component.
`java.awt.Dimension` | `getMinimumSize()` If the minimum size has been set to a non-`null` value just returns it.
`java.awt.Dimension` | `getPreferredSize()` If the `preferredSize` has been set to a non-`null` value just returns it.
`int` | `getWidth()` Returns the current width of this component.
`void` | `keyPressed(java.awt.event.KeyEvent e)` Invoked when a key has been pressed.
`void` | `keyReleased(java.awt.event.KeyEvent e)` Invoked when a key has been released.
`void` | `keyTyped(java.awt.event.KeyEvent e)` Invoked when a key has been typed.
`void` | `mouseClicked(java.awt.event.MouseEvent e)` Invoked when the mouse button has been clicked (pressed and released) on a component.
`void` | `mouseDragged(java.awt.event.MouseEvent e)` Invoked when a mouse button is pressed on a component and then dragged.
`void` | `mouseEntered(java.awt.event.MouseEvent e)` Invoked when the mouse enters a component.
`void` | `mouseExited(java.awt.event.MouseEvent e)` Invoked when the mouse exits a component.
`void` | `mouseMoved(java.awt.event.MouseEvent e)` Invoked when the mouse cursor has been moved onto a component but no buttons have been pushed.
`void` | `mousePressed(java.awt.event.MouseEvent e)` Invoked when a mouse button has been pressed on a component.
`void` | `mouseReleased(java.awt.event.MouseEvent e)` Invoked when a mouse button has been released on a component.
`protected void` | `paintComponent(java.awt.Graphics g)`
`int` | `read()`
`void` | `run()`
`static void` | `showTerminal(java.io.InputStream is, java.io.OutputStream os, boolean closeStreamsOnClose, javax.swing.JComponent parent, java.lang.String portType, java.lang.String portName)`
`void` | `validate()` Validates this container and all of its subcomponents.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Terminal

    public Terminal(java.io.InputStream is,
                    java.io.OutputStream os,
                    java.lang.String portName,
                    boolean echoed)

Method Detail

### getHeight

    public int getHeight()

  Returns the current height of this component. This method is preferable to writing `component.getBounds().height`, or `component.getSize().height` because it doesn't cause any heap allocations.

  Overrides:
    `getHeight` in class `javax.swing.JComponent`
  Returns:
    the current height of this component

### getWidth

    public int getWidth()

  Returns the current width of this component. This method is preferable to writing `component.getBounds().width`, or `component.getSize().width` because it doesn't cause any heap allocations.

  Overrides:
    `getWidth` in class `javax.swing.JComponent`
  Returns:
    the current width of this component

### validate

    public void validate()

  Validates this container and all of its subcomponents.

  The `validate` method is used to cause a container to lay out its subcomponents again. It should be invoked when this container's subcomponents are modified (added to or removed from the container, or layout-related information changed) after the container has been displayed.

  If this `Container` is not valid, this method invokes the `validateTree` method and marks this `Container` as valid. Otherwise, no action is performed.

  Overrides:
    `validate` in class `java.awt.Container`
  See Also:
    `Container.add(java.awt.Component)`, `Component.invalidate()`, `JComponent.revalidate()`, `Container.validateTree()`

### getMinimumSize

    public java.awt.Dimension getMinimumSize()

  If the minimum size has been set to a non-`null` value just returns it. If the UI delegate's `getMinimumSize` method returns a non-`null` value then return that; otherwise defer to the component's layout manager.

  Overrides:
    `getMinimumSize` in class `javax.swing.JComponent`
  Returns:
    the value of the `minimumSize` property

### getPreferredSize

    public java.awt.Dimension getPreferredSize()

  If the `preferredSize` has been set to a non-`null` value just returns it. If the UI delegate's `getPreferredSize` method returns a non `null` value then return that; otherwise defer to the component's layout manager.

  Overrides:
    `getPreferredSize` in class `javax.swing.JComponent`
  Returns:
    the value of the `preferredSize` property

### paintComponent

    protected void paintComponent(java.awt.Graphics g)

  Overrides:
    `paintComponent` in class `javax.swing.JComponent`
  Parameters:
    `g` - the `Graphics` object to protect

### run

    public final void run()

  Specified by:
    `run` in interface `java.lang.Runnable`

### available

    public int available()
                  throws java.io.IOException

  Throws:
    `java.io.IOException`

### read

    public int read()
             throws java.io.IOException

  Throws:
    `java.io.IOException`

### close

    public void close()

### keyPressed

    public void keyPressed(java.awt.event.KeyEvent e)

  Invoked when a key has been pressed. See the class description for `KeyEvent` for a definition of a key pressed event.

  Specified by:
    `keyPressed` in interface `java.awt.event.KeyListener`

### keyTyped

    public void keyTyped(java.awt.event.KeyEvent e)

  Invoked when a key has been typed. See the class description for `KeyEvent` for a definition of a key typed event.

  Specified by:
    `keyTyped` in interface `java.awt.event.KeyListener`

### keyReleased

    public void keyReleased(java.awt.event.KeyEvent e)

  Invoked when a key has been released. See the class description for `KeyEvent` for a definition of a key released event.

  Specified by:
    `keyReleased` in interface `java.awt.event.KeyListener`

### mouseClicked

    public void mouseClicked(java.awt.event.MouseEvent e)

  Invoked when the mouse button has been clicked (pressed and released) on a component.

  Specified by:
    `mouseClicked` in interface `java.awt.event.MouseListener`

### mousePressed

    public void mousePressed(java.awt.event.MouseEvent e)

  Invoked when a mouse button has been pressed on a component.

  Specified by:
    `mousePressed` in interface `java.awt.event.MouseListener`

### mouseReleased

    public void mouseReleased(java.awt.event.MouseEvent e)

  Invoked when a mouse button has been released on a component.

  Specified by:
    `mouseReleased` in interface `java.awt.event.MouseListener`

### mouseEntered

    public void mouseEntered(java.awt.event.MouseEvent e)

  Invoked when the mouse enters a component.

  Specified by:
    `mouseEntered` in interface `java.awt.event.MouseListener`

### mouseExited

    public void mouseExited(java.awt.event.MouseEvent e)

  Invoked when the mouse exits a component.

  Specified by:
    `mouseExited` in interface `java.awt.event.MouseListener`

### mouseDragged

    public void mouseDragged(java.awt.event.MouseEvent e)

  Invoked when a mouse button is pressed on a component and then dragged. `MOUSE_DRAGGED` events will continue to be delivered to the component where the drag originated until the mouse button is released (regardless of whether the mouse position is within the bounds of the component).

  Due to platform-dependent Drag and Drop implementations, `MOUSE_DRAGGED` events may not be delivered during a native Drag and Drop operation.

  Specified by:
    `mouseDragged` in interface `java.awt.event.MouseMotionListener`

### mouseMoved

    public void mouseMoved(java.awt.event.MouseEvent e)

  Invoked when the mouse cursor has been moved onto a component but no buttons have been pushed.

  Specified by:
    `mouseMoved` in interface `java.awt.event.MouseMotionListener`

### showTerminal

    public static void showTerminal(java.io.InputStream is,
                                    java.io.OutputStream os,
                                    boolean closeStreamsOnClose,
                                    javax.swing.JComponent parent,
                                    java.lang.String portType,
                                    java.lang.String portName)
                             throws java.io.IOException

  Throws:
    `java.io.IOException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD